码迷,mamicode.com
首页 > 其他好文 > 详细

HDU 5389 Zero Escape(dp啊 多校啊 )

时间:2015-08-13 23:44:39      阅读:347      评论:0      收藏:0      [点我收藏+]

标签:hdu   多校2015   dp   

题目链接:http://acm.hdu.edu.cn/showproblem.php?pid=5389


Problem Description
Zero Escape, is a visual novel adventure video game directed by Kotaro Uchikoshi (you may hear about ever17?) and developed by Chunsoft.

Stilwell is enjoying the first chapter of this series, and in this chapter digital root is an important factor. 

This is the definition of digital root on Wikipedia:
The digital root of a non-negative integer is the single digit value obtained by an iterative process of summing digits, on each iteration using the result from the previous iteration to compute a digit sum. The process continues until a single-digit number is reached.
For example, the digital root of 65536 is 7, because 6+5+5+3+6=25 and 2+5=7.

In the game, every player has a special identifier. Maybe two players have the same identifier, but they are different players. If a group of players want to get into a door numbered X(1X9), the digital root of their identifier sum must be X.
For example, players {1,2,6} can get into the door 9, but players {2,3,3} can‘t.

There is two doors, numbered A and B. Maybe A=B, but they are two different door.
And there is n players, everyone must get into one of these two doors. Some players will get into the door A, and others will get into the door B.
For example: 
players are {1,2,6}A=9B=1
There is only one way to distribute the players: all players get into the door 9. Because there is no player to get into the door 1, the digital root limit of this door will be ignored.

Given the identifier of every player, please calculate how many kinds of methods are there, mod 258280327.
 

Input
The first line of the input contains a single number T, the number of test cases.
For each test case, the first line contains three integers nA and B.
Next line contains n integers idi, describing the identifier of every player.
T100n105n1061A,B,idi9
 

Output
For each test case, output a single integer in a single line, the number of ways that these n players can get into these two doors.
 

Sample Input
4 3 9 1 1 2 6 3 9 1 2 3 3 5 2 3 1 1 1 1 1 9 9 9 1 2 3 4 5 6 7 8 9
 

Sample Output
1 0 10 60
 

Source


题意:(转)

一个长度为 n 的序列分为两组,使得一组的和为A,一组的和为B.

求有多少种分法!

PS:

注意这里的和定义为这些数的和的数根。

一个数的数根的计算公式为,root = (x-1)%9+1;

很明显一个正整数的数根是1~9的分析,如果这n个数的数根分成两组使得

一组的数根为A,一组的数根为B那么这两组的数的和的数根等于(A+B)的

数根。因此我们只需要考虑组成其中一个数的情况,然后再最后进行一个

判断即可我们设dp[i][j]表示前i个数组成的数根为j的数目。

注意其中任意一组可以为空。

代码如下:

#include <cstdio>
#include <cstring>
const int mod = 258280327;
#define maxn 100017
int dp[maxn][10];
//dp[i][j]:前i个数能组成j的方案数

int num[maxn];
int cal(int x, int y)
{
    int tmp = x+y;
    int ans = tmp%9;
    if(ans == 0)
    {
        return 9;
    }
    return ans;
}
int main()
{
    int t;
    int n, a, b;
    scanf("%d",&t);
    while(t--)
    {
        int sum = 0;
        memset(dp,0,sizeof(dp));
        scanf("%d%d%d",&n,&a,&b);
        for(int i = 1; i <= n; i++)
        {
            scanf("%d",&num[i]);
            sum = cal(sum,num[i]);
        }
        dp[0][0] = 1;
        for(int i = 1; i <= n; i++)
        {
            for(int j = 0; j <= 9; j++)
            {
                dp[i][j]+=dp[i-1][j];
                dp[i][j]%=mod;
                int tt = cal(num[i],j);
                dp[i][tt]+=dp[i-1][j];
                dp[i][tt]%=mod;
            }
        }
        int ans = 0;
        if(cal(a, b) == sum)
        {
            ans+=dp[n][a];
            if(a == sum)
            {
                ans--;
            }
        }
        if(sum == a)//都分给a
        {
            ans++;
        }
        if(sum == b)//都分给b
        {
            ans++;
        }
        printf("%d\n",ans);
    }
    return 0;
}


版权声明:本文为博主原创文章,未经博主允许不得转载。

HDU 5389 Zero Escape(dp啊 多校啊 )

标签:hdu   多校2015   dp   

原文地址:http://blog.csdn.net/u012860063/article/details/47622949

(0)
(0)
   
举报
评论 一句话评论(0
登录后才能评论!
© 2014 mamicode.com 版权所有  联系我们:gaon5@hotmail.com
迷上了代码!